/* This file has been generated by the Perl script `afblue.pl', */
/* using data from file `afblue.dat'.                           */

/***************************************************************************/
/*                                                                         */
/*  afblue.h                                                               */
/*                                                                         */
/*    Auto-fitter data for blue strings (specification).                   */
/*                                                                         */
/*  Copyright 2013-2017 by                                                 */
/*  David Turner, Robert Wilhelm, and Werner Lemberg.                      */
/*                                                                         */
/*  This file is part of the FreeType project, and may only be used,       */
/*  modified, and distributed under the terms of the FreeType project      */
/*  license, LICENSE.TXT.  By continuing to use, modify, or distribute     */
/*  this file you indicate that you have read the license and              */
/*  understand and accept it fully.                                        */
/*                                                                         */
/***************************************************************************/


#ifndef AFBLUE_H_
#define AFBLUE_H_


FT_BEGIN_HEADER


  /* an auxiliary macro to decode a UTF-8 character -- since we only use */
  /* hard-coded, self-converted data, no error checking is performed     */
#define GET_UTF8_CHAR( ch, p )                      \
          do                                        \
          {                                         \
            ch = (unsigned char)*p++;               \
            if ( ch >= 0x80 )                       \
            {                                       \
              FT_UInt  len_;                        \
                                                    \
                                                    \
              if ( ch < 0xE0 )                      \
              {                                     \
                len_ = 1;                           \
                ch  &= 0x1F;                        \
              }                                     \
              else if ( ch < 0xF0 )                 \
              {                                     \
                len_ = 2;                           \
                ch  &= 0x0F;                        \
              }                                     \
              else                                  \
              {                                     \
                len_ = 3;                           \
                ch  &= 0x07;                        \
              }                                     \
                                                    \
              for ( ; len_ > 0; len_-- )            \
                ch = ( ch << 6 ) | ( *p++ & 0x3F ); \
            }                                       \
          } while ( 0 )


  /*************************************************************************/
  /*************************************************************************/
  /*****                                                               *****/
  /*****                    B L U E   S T R I N G S                    *****/
  /*****                                                               *****/
  /*************************************************************************/
  /*************************************************************************/

  /* At the bottommost level, we define strings for finding blue zones. */


#define AF_BLUE_STRING_MAX_LEN  51

  /* The AF_Blue_String enumeration values are offsets into the */
  /* `af_blue_strings' array.                                   */

  typedef enum  AF_Blue_String_
  {
    AF_BLUE_STRING_ADLAM_CAPITAL_TOP = 0,
    AF_BLUE_STRING_ADLAM_CAPITAL_BOTTOM = 30,
    AF_BLUE_STRING_ADLAM_SMALL_TOP = 40,
    AF_BLUE_STRING_ADLAM_SMALL_BOTTOM = 65,
    AF_BLUE_STRING_ARABIC_TOP = 105,
    AF_BLUE_STRING_ARABIC_BOTTOM = 123,
    AF_BLUE_STRING_ARABIC_JOIN = 138,
    AF_BLUE_STRING_ARMENIAN_CAPITAL_TOP = 141,
    AF_BLUE_STRING_ARMENIAN_CAPITAL_BOTTOM = 165,
    AF_BLUE_STRING_ARMENIAN_SMALL_ASCENDER = 189,
    AF_BLUE_STRING_ARMENIAN_SMALL_TOP = 210,
    AF_BLUE_STRING_ARMENIAN_SMALL_BOTTOM = 234,
    AF_BLUE_STRING_ARMENIAN_SMALL_DESCENDER = 258,
    AF_BLUE_STRING_AVESTAN_TOP = 282,
    AF_BLUE_STRING_AVESTAN_BOTTOM = 302,
    AF_BLUE_STRING_BENGALI_BASE = 312,
    AF_BLUE_STRING_BENGALI_TOP = 344,
    AF_BLUE_STRING_BENGALI_HEAD = 372,
    AF_BLUE_STRING_CHEROKEE_CAPITAL = 404,
    AF_BLUE_STRING_CHEROKEE_SMALL_ASCENDER = 436,
    AF_BLUE_STRING_CHEROKEE_SMALL = 468,
    AF_BLUE_STRING_CHEROKEE_SMALL_DESCENDER = 500,
    AF_BLUE_STRING_CYPRIOT_TOP = 516,
    AF_BLUE_STRING_CYPRIOT_BOTTOM = 556,
    AF_BLUE_STRING_CYPRIOT_SMALL = 591,
    AF_BLUE_STRING_CYRILLIC_CAPITAL_TOP = 606,
    AF_BLUE_STRING_CYRILLIC_CAPITAL_BOTTOM = 630,
    AF_BLUE_STRING_CYRILLIC_SMALL = 654,
    AF_BLUE_STRING_CYRILLIC_SMALL_DESCENDER = 678,
    AF_BLUE_STRING_DESERET_CAPITAL_TOP = 687,
    AF_BLUE_STRING_DESERET_CAPITAL_BOTTOM = 712,
    AF_BLUE_STRING_DESERET_SMALL_TOP = 737,
    AF_BLUE_STRING_DESERET_SMALL_BOTTOM = 762,
    AF_BLUE_STRING_DEVANAGARI_BASE = 787,
    AF_BLUE_STRING_DEVANAGARI_TOP = 819,
    AF_BLUE_STRING_DEVANAGARI_HEAD = 851,
    AF_BLUE_STRING_DEVANAGARI_BOTTOM = 883,
    AF_BLUE_STRING_ETHIOPIC_TOP = 891,
    AF_BLUE_STRING_ETHIOPIC_BOTTOM = 923,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_TOP = 955,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_BOTTOM = 987,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_ASCENDER = 1019,
    AF_BLUE_STRING_GEORGIAN_MKHEDRULI_DESCENDER = 1051,
    AF_BLUE_STRING_GEORGIAN_ASOMTAVRULI_TOP = 1083,
    AF_BLUE_STRING_GEORGIAN_ASOMTAVRULI_BOTTOM = 1115,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_TOP = 1147,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_BOTTOM = 1179,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_ASCENDER = 1211,
    AF_BLUE_STRING_GEORGIAN_NUSKHURI_DESCENDER = 1243,
    AF_BLUE_STRING_GLAGOLITIC_CAPITAL_TOP = 1275,
    AF_BLUE_STRING_GLAGOLITIC_CAPITAL_BOTTOM = 1307,
    AF_BLUE_STRING_GLAGOLITIC_SMALL_TOP = 1339,
    AF_BLUE_STRING_GLAGOLITIC_SMALL_BOTTOM = 1371,
    AF_BLUE_STRING_GOTHIC_TOP = 1403,
    AF_BLUE_STRING_GOTHIC_BOTTOM = 1443,
    AF_BLUE_STRING_GREEK_CAPITAL_TOP = 1463,
    AF_BLUE_STRING_GREEK_CAPITAL_BOTTOM = 1484,
    AF_BLUE_STRING_GREEK_SMALL_BETA_TOP = 1502,
    AF_BLUE_STRING_GREEK_SMALL = 1520,
    AF_BLUE_STRING_GREEK_SMALL_DESCENDER = 1544,
    AF_BLUE_STRING_GUJARATI_TOP = 1568,
    AF_BLUE_STRING_GUJARATI_BOTTOM = 1600,
    AF_BLUE_STRING_GUJARATI_ASCENDER = 1632,
    AF_BLUE_STRING_GUJARATI_DESCENDER = 1682,
    AF_BLUE_STRING_GUJARATI_DIGIT_TOP = 1715,
    AF_BLUE_STRING_GURMUKHI_BASE = 1735,
    AF_BLUE_STRING_GURMUKHI_HEAD = 1767,
    AF_BLUE_STRING_GURMUKHI_TOP = 1799,
    AF_BLUE_STRING_GURMUKHI_BOTTOM = 1831,
    AF_BLUE_STRING_GURMUKHI_DIGIT_TOP = 1863,
    AF_BLUE_STRING_HEBREW_TOP = 1883,
    AF_BLUE_STRING_HEBREW_BOTTOM = 1907,
    AF_BLUE_STRING_HEBREW_DESCENDER = 1925,
    AF_BLUE_STRING_KANNADA_TOP = 1940,
    AF_BLUE_STRING_KANNADA_BOTTOM = 1984,
    AF_BLUE_STRING_KHMER_TOP = 2016,
    AF_BLUE_STRING_KHMER_SUBSCRIPT_TOP = 2040,
    AF_BLUE_STRING_KHMER_BOTTOM = 2080,
    AF_BLUE_STRING_KHMER_DESCENDER = 2112,
    AF_BLUE_STRING_KHMER_LARGE_DESCENDER = 2146,
    AF_BLUE_STRING_KHMER_SYMBOLS_WAXING_TOP = 2233,
    AF_BLUE_STRING_KHMER_SYMBOLS_WANING_BOTTOM = 2241,
    AF_BLUE_STRING_LAO_TOP = 2249,
    AF_BLUE_STRING_LAO_BOTTOM = 2281,
    AF_BLUE_STRING_LAO_ASCENDER = 2313,
    AF_BLUE_STRING_LAO_LARGE_ASCENDER = 2329,
    AF_BLUE_STRING_LAO_DESCENDER = 2341,
    AF_BLUE_STRING_LATIN_CAPITAL_TOP = 2365,
    AF_BLUE_STRING_LATIN_CAPITAL_BOTTOM = 2381,
    AF_BLUE_STRING_LATIN_SMALL_F_TOP = 2397,
    AF_BLUE_STRING_LATIN_SMALL_TOP = 2411,
    AF_BLUE_STRING_LATIN_SMALL_BOTTOM = 2427,
    AF_BLUE_STRING_LATIN_SMALL_DESCENDER = 2443,
    AF_BLUE_STRING_LATIN_SUBS_CAPITAL_TOP = 2453,
    AF_BLUE_STRING_LATIN_SUBS_CAPITAL_BOTTOM = 2473,
    AF_BLUE_STRING_LATIN_SUBS_SMALL_F_TOP = 2493,
    AF_BLUE_STRING_LATIN_SUBS_SMALL = 2513,
    AF_BLUE_STRING_LATIN_SUBS_SMALL_DESCENDER = 2549,
    AF_BLUE_STRING_LATIN_SUPS_CAPITAL_TOP = 2569,
    AF_BLUE_STRING_LATIN_SUPS_CAPITAL_BOTTOM = 2600,
    AF_BLUE_STRING_LATIN_SUPS_SMALL_F_TOP = 2629,
    AF_BLUE_STRING_LATIN_SUPS_SMALL = 2655,
    AF_BLUE_STRING_LATIN_SUPS_SMALL_DESCENDER = 2680,
    AF_BLUE_STRING_LISU_TOP = 2691,
    AF_BLUE_STRING_LISU_BOTTOM = 2723,
    AF_BLUE_STRING_MALAYALAM_TOP = 2755,
    AF_BLUE_STRING_MALAYALAM_BOTTOM = 2799,
    AF_BLUE_STRING_MYANMAR_TOP = 2831,
    AF_BLUE_STRING_MYANMAR_BOTTOM = 2863,
    AF_BLUE_STRING_MYANMAR_ASCENDER = 2895,
    AF_BLUE_STRING_MYANMAR_DESCENDER = 2923,
    AF_BLUE_STRING_NKO_TOP = 2955,
    AF_BLUE_STRING_NKO_BOTTOM = 2979,
    AF_BLUE_STRING_NKO_SMALL_TOP = 2994,
    AF_BLUE_STRING_NKO_SMALL_BOTTOM = 3003,
    AF_BLUE_STRING_OL_CHIKI = 3015,
    AF_BLUE_STRING_OLD_TURKIC_TOP = 3039,
    AF_BLUE_STRING_OLD_TURKIC_BOTTOM = 3054,
    AF_BLUE_STRING_OSAGE_CAPITAL_TOP = 3074,
    AF_BLUE_STRING_OSAGE_CAPITAL_BOTTOM = 3114,
    AF_BLUE_STRING_OSAGE_CAPITAL_DESCENDER = 3144,
    AF_BLUE_STRING_OSAGE_SMALL_TOP = 3159,
    AF_BLUE_STRING_OSAGE_SMALL_BOTTOM = 3199,
    AF_BLUE_STRING_OSAGE_SMALL_ASCENDER = 3239,
    AF_BLUE_STRING_OSAGE_SMALL_DESCENDER = 3264,
    AF_BLUE_STRING_SINHALA_TOP = 3279,
    AF_BLUE_STRING_SINHALA_BOTTOM = 3311,
    AF_BLUE_STRING_SINHALA_DESCENDER = 3343,
    AF_BLUE_STRING_SUNDANESE_TOP = 3387,
    AF_BLUE_STRING_SUNDANESE_BOTTOM = 3411,
    AF_BLUE_STRING_SUNDANESE_DESCENDER = 3443,
    AF_BLUE_STRING_TAI_VIET_TOP = 3451,
    AF_BLUE_STRING_TAI_VIET_BOTTOM = 3471,
    AF_BLUE_STRING_TAMIL_TOP = 3483,
    AF_BLUE_STRING_TAMIL_BOTTOM = 3515,
    AF_BLUE_STRING_TELUGU_TOP = 3547,
    AF_BLUE_STRING_TELUGU_BOTTOM = 3575,
    AF_BLUE_STRING_THAI_TOP = 3603,
    AF_BLUE_STRING_THAI_BOTTOM = 3627,
    AF_BLUE_STRING_THAI_ASCENDER = 3655,
    AF_BLUE_STRING_THAI_LARGE_ASCENDER = 3667,
    AF_BLUE_STRING_THAI_DESCENDER = 3679,
    AF_BLUE_STRING_THAI_LARGE_DESCENDER = 3695,
    AF_BLUE_STRING_THAI_DIGIT_TOP = 3703,
    AF_BLUE_STRING_TIFINAGH = 3715,
    af_blue_1_1 = 3746,
#ifdef AF_CONFIG_OPTION_CJK
    AF_BLUE_STRING_CJK_TOP = af_blue_1_1 + 1,
    AF_BLUE_STRING_CJK_BOTTOM = af_blue_1_1 + 203,
    af_blue_1_1_1 = af_blue_1_1 + 404,
#ifdef AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT
    AF_BLUE_STRING_CJK_LEFT = af_blue_1_1_1 + 1,
    AF_BLUE_STRING_CJK_RIGHT = af_blue_1_1_1 + 204,
    af_blue_1_1_2 = af_blue_1_1_1 + 405,
#else
    af_blue_1_1_2 = af_blue_1_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT */
    af_blue_1_2 = af_blue_1_1_2 + 0,
#else
    af_blue_1_2 = af_blue_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK                */


    AF_BLUE_STRING_MAX   /* do not remove */

  } AF_Blue_String;


  FT_LOCAL_ARRAY( char )
  af_blue_strings[];


  /*************************************************************************/
  /*************************************************************************/
  /*****                                                               *****/
  /*****                 B L U E   S T R I N G S E T S                 *****/
  /*****                                                               *****/
  /*************************************************************************/
  /*************************************************************************/

  /* The next level is to group blue strings into style-specific sets. */


  /* Properties are specific to a writing system.  We assume that a given  */
  /* blue string can't be used in more than a single writing system, which */
  /* is a safe bet.                                                        */
#define AF_BLUE_PROPERTY_LATIN_TOP       ( 1U << 0 )  /* must have value 1 */
#define AF_BLUE_PROPERTY_LATIN_SUB_TOP   ( 1U << 1 )
#define AF_BLUE_PROPERTY_LATIN_NEUTRAL   ( 1U << 2 )
#define AF_BLUE_PROPERTY_LATIN_X_HEIGHT  ( 1U << 3 )
#define AF_BLUE_PROPERTY_LATIN_LONG      ( 1U << 4 )

#define AF_BLUE_PROPERTY_CJK_TOP    ( 1U << 0 )       /* must have value 1 */
#define AF_BLUE_PROPERTY_CJK_HORIZ  ( 1U << 1 )       /* must have value 2 */
#define AF_BLUE_PROPERTY_CJK_RIGHT  AF_BLUE_PROPERTY_CJK_TOP


#define AF_BLUE_STRINGSET_MAX_LEN  8

  /* The AF_Blue_Stringset enumeration values are offsets into the */
  /* `af_blue_stringsets' array.                                   */

  typedef enum  AF_Blue_Stringset_
  {
    AF_BLUE_STRINGSET_ADLM = 0,
    AF_BLUE_STRINGSET_ARAB = 5,
    AF_BLUE_STRINGSET_ARMN = 9,
    AF_BLUE_STRINGSET_AVST = 16,
    AF_BLUE_STRINGSET_BENG = 19,
    AF_BLUE_STRINGSET_CHER = 24,
    AF_BLUE_STRINGSET_CPRT = 31,
    AF_BLUE_STRINGSET_CYRL = 36,
    AF_BLUE_STRINGSET_DEVA = 42,
    AF_BLUE_STRINGSET_DSRT = 48,
    AF_BLUE_STRINGSET_ETHI = 53,
    AF_BLUE_STRINGSET_GEOR = 56,
    AF_BLUE_STRINGSET_GEOK = 61,
    AF_BLUE_STRINGSET_GLAG = 68,
    AF_BLUE_STRINGSET_GOTH = 73,
    AF_BLUE_STRINGSET_GREK = 76,
    AF_BLUE_STRINGSET_GUJR = 83,
    AF_BLUE_STRINGSET_GURU = 89,
    AF_BLUE_STRINGSET_HEBR = 95,
    AF_BLUE_STRINGSET_KNDA = 99,
    AF_BLUE_STRINGSET_KHMR = 102,
    AF_BLUE_STRINGSET_KHMS = 108,
    AF_BLUE_STRINGSET_LAO = 111,
    AF_BLUE_STRINGSET_LATN = 117,
    AF_BLUE_STRINGSET_LATB = 124,
    AF_BLUE_STRINGSET_LATP = 131,
    AF_BLUE_STRINGSET_LISU = 138,
    AF_BLUE_STRINGSET_MLYM = 141,
    AF_BLUE_STRINGSET_MYMR = 144,
    AF_BLUE_STRINGSET_NKOO = 149,
    AF_BLUE_STRINGSET_NONE = 154,
    AF_BLUE_STRINGSET_OLCK = 155,
    AF_BLUE_STRINGSET_ORKH = 158,
    AF_BLUE_STRINGSET_OSGE = 161,
    AF_BLUE_STRINGSET_SINH = 169,
    AF_BLUE_STRINGSET_SUND = 173,
    AF_BLUE_STRINGSET_TAML = 177,
    AF_BLUE_STRINGSET_TAVT = 180,
    AF_BLUE_STRINGSET_TELU = 183,
    AF_BLUE_STRINGSET_THAI = 186,
    AF_BLUE_STRINGSET_TFNG = 194,
    af_blue_2_1 = 197,
#ifdef AF_CONFIG_OPTION_CJK
    AF_BLUE_STRINGSET_HANI = af_blue_2_1 + 0,
    af_blue_2_1_1 = af_blue_2_1 + 2,
#ifdef AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT
    af_blue_2_1_2 = af_blue_2_1_1 + 2,
#else
    af_blue_2_1_2 = af_blue_2_1_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK_BLUE_HANI_VERT */
    af_blue_2_2 = af_blue_2_1_2 + 1,
#else
    af_blue_2_2 = af_blue_2_1 + 0,
#endif /* AF_CONFIG_OPTION_CJK                */


    AF_BLUE_STRINGSET_MAX   /* do not remove */

  } AF_Blue_Stringset;


  typedef struct  AF_Blue_StringRec_
  {
    AF_Blue_String  string;
    FT_UShort       properties;

  } AF_Blue_StringRec;


  FT_LOCAL_ARRAY( AF_Blue_StringRec )
  af_blue_stringsets[];

/* */

FT_END_HEADER


#endif /* AFBLUE_H_ */


/* END */
